taffybar-3.0.0: A desktop bar similar to xmobar, but with more GUI

Copyright | (c) Ivan A. Malison
License | BSD3-style (see LICENSE)
Maintainer | Ivan A. Malison
Stability | unstable
Portability | unportable
Safe Haskell | None
Language | Haskell2010

System.Taffybar.Information.SafeX11

Contents

- Orphan instances

Description

Synopsis

- module Graphics.X11.Xlib
- getModifierMapping :: Display -> IO [(Modifier, [KeyCode])]
- getCommand :: Display -> Window -> IO [String]
- getErrorEvent :: XErrorEventPtr -> IO ErrorEvent
- setErrorHandler :: XErrorHandler -> IO ()
- setWMHints :: Display -> Window -> WMHints -> IO Status
- allHintsBitmask :: CLong
- urgencyHintBit :: Int
- windowGroupHintBit :: Int
- iconMaskHintBit :: Int
- iconPositionHintBit :: Int
- iconWindowHintBit :: Int
- iconPixmapHintBit :: Int
- stateHintBit :: Int
- inputHintBit :: Int
- iconicState :: Int
- normalState :: Int
- withdrawnState :: Int
- getClassHint :: Display -> Window -> IO ClassHint
- getWMNormalHints :: Display -> Window -> IO SizeHints
- pWinGravityBit :: Int
- pBaseSizeBit :: Int
- pAspectBit :: Int
- pResizeIncBit :: Int
- pMaxSizeBit :: Int
- pMinSizeBit :: Int
- unmapWindow :: Display -> Window -> IO ()
- deleteProperty :: Display -> Window -> Atom -> IO ()
- propModeAppend :: CInt
- propModePrepend :: CInt
- propModeReplace :: CInt
- changeProperty32 :: Display -> Window -> Atom -> Atom -> CInt -> [CLong] -> IO ()
- changeProperty16 :: Display -> Window -> Atom -> Atom -> CInt -> [CShort] -> IO ()
- changeProperty8 :: Display -> Window -> Atom -> Atom -> CInt -> [CChar] -> IO ()
- anyPropertyType :: Atom
- setKeyEvent :: XEventPtr -> Window -> Window -> Window -> KeyMask -> KeyCode -> Bool -> IO ()
- setConfigureEvent :: XEventPtr -> Window -> Window -> CInt -> CInt -> CInt -> CInt -> CInt -> Window -> Bool -> IO ()
- setClientMessageEvent :: XEventPtr -> Window -> Atom -> CInt -> Atom -> Time -> IO ()
- setSelectionNotify :: XEventPtr -> Window -> Atom -> Atom -> Atom -> Time -> IO ()
- setEventType :: XEventPtr -> EventType -> IO ()
- getWMProtocols :: Display -> Window -> IO [Atom]
- getTransientForHint :: Display -> Window -> IO (Maybe Window)
- fetchName :: Display -> Window -> IO (Maybe String)
- wcTextEscapement :: FontSet -> String -> Int32
- wcDrawImageString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> String -> IO ()
- wcDrawString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> String -> IO ()
- wcTextExtents :: FontSet -> String -> (Rectangle, Rectangle)
- createFontSet :: Display -> String -> IO ([String], String, FontSet)
- wcTextPropertyToTextList :: Display -> TextProperty -> IO [String]
- getTextProperty :: Display -> Window -> Atom -> IO TextProperty
- withServer :: Display -> IO () -> IO ()
- getWindowAttributes :: Display -> Window -> IO WindowAttributes
- waIsViewable :: CInt
- waIsUnviewable :: CInt
- waIsUnmapped :: CInt
- queryTree :: Display -> Window -> IO (Window, Window, [Window])
- configureWindow :: Display -> Window -> CULong -> WindowChanges -> IO ()
- currentTime :: Time
- anyKey :: KeyCode
- anyButton :: Button
- none :: XID
- getEvent :: XEventPtr -> IO Event
- eventName :: Event -> String
- eventTable :: [(EventType, String)]
- xConfigureWindow :: Display -> Window -> CULong -> Ptr WindowChanges -> IO CInt
- killClient :: Display -> Window -> IO CInt
- xQueryTree :: Display -> Window -> Ptr Window -> Ptr Window -> Ptr (Ptr Window) -> Ptr CInt -> IO Status
- xGetWindowAttributes :: Display -> Window -> Ptr WindowAttributes -> IO Status
- changeWindowAttributes :: Display -> Window -> AttributeMask -> Ptr SetWindowAttributes -> IO ()
- xGetTextProperty :: Display -> Window -> Ptr TextProperty -> Atom -> IO Status
- xwcTextPropertyToTextList :: Display -> Ptr TextProperty -> Ptr (Ptr CWString) -> Ptr CInt -> IO CInt
- wcFreeStringList :: Ptr CWString -> IO ()
- xCreateFontSet :: Display -> CString -> Ptr (Ptr CString) -> Ptr CInt -> Ptr CString -> IO (Ptr FontSet)
- freeStringList :: Ptr CString -> IO ()
- freeFontSet :: Display -> FontSet -> IO ()
- xwcTextExtents :: FontSet -> CWString -> CInt -> Ptr Rectangle -> Ptr Rectangle -> IO CInt
- xwcDrawString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> CWString -> CInt -> IO ()
- xwcDrawImageString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> CWString -> CInt -> IO ()
- xwcTextEscapement :: FontSet -> CWString -> CInt -> IO Int32
- xFetchName :: Display -> Window -> Ptr CString -> IO Status
- xGetTransientForHint :: Display -> Window -> Ptr Window -> IO Status
- xGetWMProtocols :: Display -> Window -> Ptr (Ptr Atom) -> Ptr CInt -> IO Status
- xSetErrorHandler :: IO ()
- xRefreshKeyboardMapping :: Ptr () -> IO CInt
- xChangeProperty :: Display -> Window -> Atom -> Atom -> CInt -> CInt -> Ptr CUChar -> CInt -> IO Status
- xDeleteProperty :: Display -> Window -> Atom -> IO Status
- xGetWindowProperty :: Display -> Window -> Atom -> CLong -> CLong -> Bool -> Atom -> Ptr Atom -> Ptr CInt -> Ptr CULong -> Ptr CULong -> Ptr (Ptr CUChar) -> IO Status
- xUnmapWindow :: Display -> Window -> IO CInt
- xGetWMNormalHints :: Display -> Window -> Ptr SizeHints -> Ptr CLong -> IO Status
- xGetClassHint :: Display -> Window -> Ptr ClassHint -> IO Status
- xAllocWMHints :: IO (Ptr WMHints)
- xSetWMHints :: Display -> Window -> Ptr WMHints -> IO Status
- isCursorKey :: KeySym -> Bool
- isFunctionKey :: KeySym -> Bool
- isKeypadKey :: KeySym -> Bool
- isMiscFunctionKey :: KeySym -> Bool
- isModifierKey :: KeySym -> Bool
- isPFKey :: KeySym -> Bool
- isPrivateKeypadKey :: KeySym -> Bool
- xSetSelectionOwner :: Display -> Atom -> Window -> Time -> IO ()
- xGetSelectionOwner :: Display -> Atom -> IO Window
- xConvertSelection :: Display -> Atom -> Atom -> Atom -> Window -> Time -> IO ()
- mkXErrorHandler :: CXErrorHandler -> IO (FunPtr CXErrorHandler)
- getXErrorHandler :: FunPtr CXErrorHandler -> CXErrorHandler
- _xSetErrorHandler :: FunPtr CXErrorHandler -> IO (FunPtr CXErrorHandler)
- mapRaised :: Display -> Window -> IO CInt
- xGetCommand :: Display -> Window -> Ptr (Ptr CWString) -> Ptr CInt -> IO Status
- xGetModifierMapping :: Display -> IO (Ptr ())
- xFreeModifiermap :: Ptr () -> IO (Ptr CInt)
- data Event
  - = AnyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    }
  - | ConfigureRequestEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_parent :: !Window
    - ev_window :: !Window
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_width :: !CInt
    - ev_height :: !CInt
    - ev_border_width :: !CInt
    - ev_above :: !Window
    - ev_detail :: !NotifyDetail
    - ev_value_mask :: !CULong
    }
  - | ConfigureEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_event :: !Window
    - ev_window :: !Window
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_width :: !CInt
    - ev_height :: !CInt
    - ev_border_width :: !CInt
    - ev_above :: !Window
    - ev_override_redirect :: !Bool
    }
  - | MapRequestEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_parent :: !Window
    - ev_window :: !Window
    }
  - | KeyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_root :: !Window
    - ev_subwindow :: !Window
    - ev_time :: !Time
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_x_root :: !CInt
    - ev_y_root :: !CInt
    - ev_state :: !KeyMask
    - ev_keycode :: !KeyCode
    - ev_same_screen :: !Bool
    }
  - | ButtonEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_root :: !Window
    - ev_subwindow :: !Window
    - ev_time :: !Time
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_x_root :: !CInt
    - ev_y_root :: !CInt
    - ev_state :: !KeyMask
    - ev_button :: !Button
    - ev_same_screen :: !Bool
    }
  - | MotionEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_window :: !Window
    }
  - | DestroyWindowEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_event :: !Window
    - ev_window :: !Window
    }
  - | UnmapEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_event :: !Window
    - ev_window :: !Window
    - ev_from_configure :: !Bool
    }
  - | MapNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_event :: !Window
    - ev_window :: !Window
    - ev_override_redirect :: !Bool
    }
  - | MappingNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_request :: !MappingRequest
    - ev_first_keycode :: !KeyCode
    - ev_count :: !CInt
    }
  - | CrossingEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_root :: !Window
    - ev_subwindow :: !Window
    - ev_time :: !Time
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_x_root :: !CInt
    - ev_y_root :: !CInt
    - ev_mode :: !NotifyMode
    - ev_detail :: !NotifyDetail
    - ev_same_screen :: !Bool
    - ev_focus :: !Bool
    - ev_state :: !Modifier
    }
  - | SelectionRequest {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_owner :: !Window
    - ev_requestor :: !Window
    - ev_selection :: !Atom
    - ev_target :: !Atom
    - ev_property :: !Atom
    - ev_time :: !Time
    }
  - | SelectionClear {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_selection :: !Atom
    - ev_time :: !Time
    }
  - | PropertyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_atom :: !Atom
    - ev_time :: !Time
    - ev_propstate :: !CInt
    }
  - | ExposeEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_width :: !CInt
    - ev_height :: !CInt
    - ev_count :: !CInt
    }
  - | ClientMessageEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_message_type :: !Atom
    - ev_data :: ![CInt]
    }
  - | RRScreenChangeNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_root :: !Window
    - ev_timestamp :: !Time
    - ev_config_timestamp :: !Time
    - ev_size_index :: !SizeID
    - ev_subpixel_order :: !SubpixelOrder
    - ev_rotation :: !Rotation
    - ev_width :: !CInt
    - ev_height :: !CInt
    - ev_mwidth :: !CInt
    - ev_mheight :: !CInt
    }
  - | RRNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_subtype :: !CInt
    }
  - | RRCrtcChangeNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_subtype :: !CInt
    - ev_crtc :: !RRCrtc
    - ev_rr_mode :: !RRMode
    - ev_rotation :: !Rotation
    - ev_x :: !CInt
    - ev_y :: !CInt
    - ev_rr_width :: !CUInt
    - ev_rr_height :: !CUInt
    }
  - | RROutputChangeNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_subtype :: !CInt
    - ev_output :: !RROutput
    - ev_crtc :: !RRCrtc
    - ev_rr_mode :: !RRMode
    - ev_rotation :: !Rotation
    - ev_connection :: !Connection
    - ev_subpixel_order :: !SubpixelOrder
    }
  - | RROutputPropertyNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_subtype :: !CInt
    - ev_output :: !RROutput
    - ev_property :: !Atom
    - ev_timestamp :: !Time
    - ev_rr_state :: !CInt
    }
  - | ScreenSaverNotifyEvent {
    - ev_event_type :: !EventType
    - ev_serial :: !CULong
    - ev_send_event :: !Bool
    - ev_event_display :: Display
    - ev_window :: !Window
    - ev_root :: !Window
    - ev_ss_state :: !XScreenSaverState
    - ev_ss_kind :: !XScreenSaverKind
    - ev_forced :: !Bool
    - ev_time :: !Time
    }
- data WindowChanges = WindowChanges {
  - wc_x :: CInt
  - wc_y :: CInt
  - wc_width :: CInt
  - wc_height :: CInt
  - wc_border_width :: CInt
  - wc_sibling :: Window
  - wc_stack_mode :: CInt
  }
- data WindowAttributes = WindowAttributes {
  - wa_x :: CInt
  - wa_y :: CInt
  - wa_width :: CInt
  - wa_height :: CInt
  - wa_border_width :: CInt
  - wa_colormap :: Colormap
  - wa_map_installed :: Bool
  - wa_map_state :: CInt
  - wa_override_redirect :: Bool
  }
- data TextProperty = TextProperty {
  - tp_value :: CString
  - tp_encoding :: Atom
  - tp_format :: CInt
  - tp_nitems :: Word64
  }
- newtype FontSet = FontSet (Ptr FontSet)
- data SizeHints = SizeHints {
  - sh_min_size :: Maybe (Dimension, Dimension)
  - sh_max_size :: Maybe (Dimension, Dimension)
  - sh_resize_inc :: Maybe (Dimension, Dimension)
  - sh_aspect :: Maybe ((Dimension, Dimension), (Dimension, Dimension))
  - sh_base_size :: Maybe (Dimension, Dimension)
  - sh_win_gravity :: Maybe BitGravity
  }
- data ClassHint = ClassHint {
  - resName :: String
  - resClass :: String
  }
- data WMHints = WMHints {
  - wmh_flags :: CLong
  - wmh_input :: Bool
  - wmh_initial_state :: CInt
  - wmh_icon_pixmap :: Pixmap
  - wmh_icon_window :: Window
  - wmh_icon_x :: CInt
  - wmh_icon_y :: CInt
  - wmh_icon_mask :: Pixmap
  - wmh_window_group :: XID
  }
- type XErrorEventPtr = Ptr ()
- type CXErrorHandler = Display -> XErrorEventPtr -> IO CInt
- type XErrorHandler = Display -> XErrorEventPtr -> IO ()
- data ErrorEvent = ErrorEvent {
  - ev_type :: !CInt
  - ev_display :: Display
  - ev_serialnum :: !CULong
  - ev_error_code :: !CUChar
  - ev_request_code :: !CUChar
  - ev_minor_code :: !CUChar
  - ev_resourceid :: !XID
  }
- xFree :: Ptr a -> IO CInt
- data IORequest = IORequest {
  - ioAction :: IO a
  - ioResponse :: Chan (Either SafeX11Exception a)
  }
- data SafeX11Exception = SafeX11Exception
- xGetGeometry :: Display -> Drawable -> Ptr Window -> Ptr Position -> Ptr Position -> Ptr Dimension -> Ptr Dimension -> Ptr Dimension -> Ptr CInt -> IO Status
- safeXGetWindowProperty :: Display -> Window -> Atom -> CLong -> CLong -> Bool -> Atom -> Ptr Atom -> Ptr CInt -> Ptr CULong -> Ptr CULong -> Ptr (Ptr CUChar) -> IO Status
- safeXGetWMHints :: Display -> Window -> IO (Ptr WMHints)
- rawGetWindowPropertyBytes :: Storable a => Int -> Display -> Atom -> Window -> IO (Maybe (ForeignPtr a, Int))
- requestQueue :: Chan IORequest
- x11Thread :: ThreadId
- withErrorHandler :: XErrorHandler -> IO a -> IO a
- startHandlingX11Requests :: IO ()
- handleX11Requests :: IO ()
- postX11RequestSync :: IO a -> IO (Either SafeX11Exception a)
- postX11RequestSyncDef :: a -> IO a -> IO a
- rawGetWindowProperty :: Storable a => Int -> Display -> Atom -> Window -> IO (Maybe [a])
- getWindowProperty8 :: Display -> Atom -> Window -> IO (Maybe [CChar])
- getWindowProperty16 :: Display -> Atom -> Window -> IO (Maybe [CShort])
- getWindowProperty32 :: Display -> Atom -> Window -> IO (Maybe [CLong])
- getWMHints :: Display -> Window -> IO WMHints
- safeGetGeometry :: Display -> Drawable -> IO (Window, Position, Position, Dimension, Dimension, Dimension, CInt)
- outParameters7 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f, Storable g) => (IO r -> IO ()) -> (Ptr a -> Ptr b -> Ptr c -> Ptr d -> Ptr e -> Ptr f -> Ptr g -> IO r) -> IO (a, b, c, d, e, f, g)

# Documentation

module Graphics.X11.Xlib

getModifierMapping :: Display -> IO [(Modifier, [KeyCode])] Source #

getCommand :: Display -> Window -> IO [String] Source #

getErrorEvent :: XErrorEventPtr -> IO ErrorEvent Source #

Retrieves error event data from a pointer to an XErrorEvent and puts it into an ErrorEvent.

setErrorHandler :: XErrorHandler -> IO () Source #

A binding to XSetErrorHandler. NOTE: This is pretty experimental because of safe vs. unsafe calls. I changed sync to a safe call, but there *might* be other calls that cause a problem

setWMHints :: Display -> Window -> WMHints -> IO Status Source #

allHintsBitmask :: CLong Source #

urgencyHintBit :: Int Source #

windowGroupHintBit :: Int Source #

iconMaskHintBit :: Int Source #

iconPositionHintBit :: Int Source #

iconWindowHintBit :: Int Source #

iconPixmapHintBit :: Int Source #

stateHintBit :: Int Source #

inputHintBit :: Int Source #

iconicState :: Int Source #

normalState :: Int Source #

withdrawnState :: Int Source #

getClassHint :: Display -> Window -> IO ClassHint Source #

getWMNormalHints :: Display -> Window -> IO SizeHints Source #

pWinGravityBit :: Int Source #

pBaseSizeBit :: Int Source #

pAspectBit :: Int Source #

pResizeIncBit :: Int Source #

pMaxSizeBit :: Int Source #

pMinSizeBit :: Int Source #

unmapWindow :: Display -> Window -> IO () Source #

deleteProperty :: Display -> Window -> Atom -> IO () Source #

propModeAppend :: CInt Source #

propModePrepend :: CInt Source #

propModeReplace :: CInt Source #

changeProperty32 :: Display -> Window -> Atom -> Atom -> CInt -> [CLong] -> IO () Source #

changeProperty16 :: Display -> Window -> Atom -> Atom -> CInt -> [CShort] -> IO () Source #

changeProperty8 :: Display -> Window -> Atom -> Atom -> CInt -> [CChar] -> IO () Source #

anyPropertyType :: Atom Source #

setKeyEvent :: XEventPtr -> Window -> Window -> Window -> KeyMask -> KeyCode -> Bool -> IO () Source #

setConfigureEvent :: XEventPtr -> Window -> Window -> CInt -> CInt -> CInt -> CInt -> CInt -> Window -> Bool -> IO () Source #

setClientMessageEvent :: XEventPtr -> Window -> Atom -> CInt -> Atom -> Time -> IO () Source #

setSelectionNotify :: XEventPtr -> Window -> Atom -> Atom -> Atom -> Time -> IO () Source #

setEventType :: XEventPtr -> EventType -> IO () Source #

getWMProtocols :: Display -> Window -> IO [Atom] Source #

The XGetWMProtocols function returns the list of atoms stored in the WM_PROTOCOLS property on the specified window. These atoms describe window manager protocols in which the owner of this window is willing to participate. If the property exists, is of type ATOM, is of format 32, and the atom WM_PROTOCOLS can be interned, XGetWMProtocols sets the protocols_return argument to a list of atoms, sets the count_return argument to the number of elements in the list, and returns a nonzero status. Otherwise, it sets neither of the return arguments and returns a zero status. To release the list of atoms, use XFree.

getTransientForHint :: Display -> Window -> IO (Maybe Window) Source #

fetchName :: Display -> Window -> IO (Maybe String) Source #

wcTextEscapement :: FontSet -> String -> Int32 Source #

wcDrawImageString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> String -> IO () Source #

wcDrawString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> String -> IO () Source #

wcTextExtents :: FontSet -> String -> (Rectangle, Rectangle) Source #

createFontSet :: Display -> String -> IO ([String], String, FontSet) Source #

wcTextPropertyToTextList :: Display -> TextProperty -> IO [String] Source #

getTextProperty :: Display -> Window -> Atom -> IO TextProperty Source #

withServer :: Display -> IO () -> IO () Source #

Run an action with the server

getWindowAttributes :: Display -> Window -> IO WindowAttributes Source #

waIsViewable :: CInt Source #

waIsUnviewable :: CInt Source #

waIsUnmapped :: CInt Source #

queryTree :: Display -> Window -> IO (Window, Window, [Window]) Source #

configureWindow :: Display -> Window -> CULong -> WindowChanges -> IO () Source #

currentTime :: Time Source #

anyKey :: KeyCode Source #

anyButton :: Button Source #

none :: XID Source #

getEvent :: XEventPtr -> IO Event Source #

eventName :: Event -> String Source #

eventTable :: [(EventType, String)] Source #

xConfigureWindow :: Display -> Window -> CULong -> Ptr WindowChanges -> IO CInt Source #

killClient :: Display -> Window -> IO CInt Source #

xQueryTree :: Display -> Window -> Ptr Window -> Ptr Window -> Ptr (Ptr Window) -> Ptr CInt -> IO Status Source #

xGetWindowAttributes :: Display -> Window -> Ptr WindowAttributes -> IO Status Source #

changeWindowAttributes :: Display -> Window -> AttributeMask -> Ptr SetWindowAttributes -> IO () Source #

interface to the X11 library function `XChangeWindowAttributes()`.

xGetTextProperty :: Display -> Window -> Ptr TextProperty -> Atom -> IO Status Source #

xwcTextPropertyToTextList :: Display -> Ptr TextProperty -> Ptr (Ptr CWString) -> Ptr CInt -> IO CInt Source #

wcFreeStringList :: Ptr CWString -> IO () Source #

xCreateFontSet :: Display -> CString -> Ptr (Ptr CString) -> Ptr CInt -> Ptr CString -> IO (Ptr FontSet) Source #

freeStringList :: Ptr CString -> IO () Source #

freeFontSet :: Display -> FontSet -> IO () Source #

xwcTextExtents :: FontSet -> CWString -> CInt -> Ptr Rectangle -> Ptr Rectangle -> IO CInt Source #

xwcDrawString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> CWString -> CInt -> IO () Source #

xwcDrawImageString :: Display -> Drawable -> FontSet -> GC -> Position -> Position -> CWString -> CInt -> IO () Source #

xwcTextEscapement :: FontSet -> CWString -> CInt -> IO Int32 Source #

xFetchName :: Display -> Window -> Ptr CString -> IO Status Source #

xGetTransientForHint :: Display -> Window -> Ptr Window -> IO Status Source #

xGetWMProtocols :: Display -> Window -> Ptr (Ptr Atom) -> Ptr CInt -> IO Status Source #

xSetErrorHandler :: IO () Source #

xRefreshKeyboardMapping :: Ptr () -> IO CInt Source #

xChangeProperty :: Display -> Window -> Atom -> Atom -> CInt -> CInt -> Ptr CUChar -> CInt -> IO Status Source #

xDeleteProperty :: Display -> Window -> Atom -> IO Status Source #

xGetWindowProperty :: Display -> Window -> Atom -> CLong -> CLong -> Bool -> Atom -> Ptr Atom -> Ptr CInt -> Ptr CULong -> Ptr CULong -> Ptr (Ptr CUChar) -> IO Status Source #

xUnmapWindow :: Display -> Window -> IO CInt Source #

xGetWMNormalHints :: Display -> Window -> Ptr SizeHints -> Ptr CLong -> IO Status Source #

xGetClassHint :: Display -> Window -> Ptr ClassHint -> IO Status Source #

xAllocWMHints :: IO (Ptr WMHints) Source #

xSetWMHints :: Display -> Window -> Ptr WMHints -> IO Status Source #

isCursorKey :: KeySym -> Bool Source #

isFunctionKey :: KeySym -> Bool Source #

isKeypadKey :: KeySym -> Bool Source #

isMiscFunctionKey :: KeySym -> Bool Source #

isModifierKey :: KeySym -> Bool Source #

isPFKey :: KeySym -> Bool Source #

isPrivateKeypadKey :: KeySym -> Bool Source #

xSetSelectionOwner :: Display -> Atom -> Window -> Time -> IO () Source #

xGetSelectionOwner :: Display -> Atom -> IO Window Source #

xConvertSelection :: Display -> Atom -> Atom -> Atom -> Window -> Time -> IO () Source #

mkXErrorHandler :: CXErrorHandler -> IO (FunPtr CXErrorHandler) Source #

getXErrorHandler :: FunPtr CXErrorHandler -> CXErrorHandler Source #

_xSetErrorHandler :: FunPtr CXErrorHandler -> IO (FunPtr CXErrorHandler) Source #

mapRaised :: Display -> Window -> IO CInt Source #

A binding to XMapRaised.

xGetCommand :: Display -> Window -> Ptr (Ptr CWString) -> Ptr CInt -> IO Status Source #

xGetModifierMapping :: Display -> IO (Ptr ()) Source #

xFreeModifiermap :: Ptr () -> IO (Ptr CInt) Source #

data Event Source #

Constructors

AnyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window

ConfigureRequestEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_parent :: !Window
- ev_window :: !Window
- ev_x :: !CInt
- ev_y :: !CInt
- ev_width :: !CInt
- ev_height :: !CInt
- ev_border_width :: !CInt
- ev_above :: !Window
- ev_detail :: !NotifyDetail
- ev_value_mask :: !CULong

ConfigureEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_event :: !Window
- ev_window :: !Window
- ev_x :: !CInt
- ev_y :: !CInt
- ev_width :: !CInt
- ev_height :: !CInt
- ev_border_width :: !CInt
- ev_above :: !Window
- ev_override_redirect :: !Bool

MapRequestEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_parent :: !Window
- ev_window :: !Window

KeyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_root :: !Window
- ev_subwindow :: !Window
- ev_time :: !Time
- ev_x :: !CInt
- ev_y :: !CInt
- ev_x_root :: !CInt
- ev_y_root :: !CInt
- ev_state :: !KeyMask
- ev_keycode :: !KeyCode
- ev_same_screen :: !Bool

ButtonEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_root :: !Window
- ev_subwindow :: !Window
- ev_time :: !Time
- ev_x :: !CInt
- ev_y :: !CInt
- ev_x_root :: !CInt
- ev_y_root :: !CInt
- ev_state :: !KeyMask
- ev_button :: !Button
- ev_same_screen :: !Bool

MotionEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_x :: !CInt
- ev_y :: !CInt
- ev_window :: !Window

DestroyWindowEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_event :: !Window
- ev_window :: !Window

UnmapEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_event :: !Window
- ev_window :: !Window
- ev_from_configure :: !Bool

MapNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_event :: !Window
- ev_window :: !Window
- ev_override_redirect :: !Bool

MappingNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_request :: !MappingRequest
- ev_first_keycode :: !KeyCode
- ev_count :: !CInt

CrossingEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_root :: !Window
- ev_subwindow :: !Window
- ev_time :: !Time
- ev_x :: !CInt
- ev_y :: !CInt
- ev_x_root :: !CInt
- ev_y_root :: !CInt
- ev_mode :: !NotifyMode
- ev_detail :: !NotifyDetail
- ev_same_screen :: !Bool
- ev_focus :: !Bool
- ev_state :: !Modifier

SelectionRequest |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_owner :: !Window
- ev_requestor :: !Window
- ev_selection :: !Atom
- ev_target :: !Atom
- ev_property :: !Atom
- ev_time :: !Time

SelectionClear |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_selection :: !Atom
- ev_time :: !Time

PropertyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_atom :: !Atom
- ev_time :: !Time
- ev_propstate :: !CInt

ExposeEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_x :: !CInt
- ev_y :: !CInt
- ev_width :: !CInt
- ev_height :: !CInt
- ev_count :: !CInt

ClientMessageEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_message_type :: !Atom
- ev_data :: ![CInt]

RRScreenChangeNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_root :: !Window
- ev_timestamp :: !Time
- ev_config_timestamp :: !Time
- ev_size_index :: !SizeID
- ev_subpixel_order :: !SubpixelOrder
- ev_rotation :: !Rotation
- ev_width :: !CInt
- ev_height :: !CInt
- ev_mwidth :: !CInt
- ev_mheight :: !CInt

RRNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_subtype :: !CInt

RRCrtcChangeNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_subtype :: !CInt
- ev_crtc :: !RRCrtc
- ev_rr_mode :: !RRMode
- ev_rotation :: !Rotation
- ev_x :: !CInt
- ev_y :: !CInt
- ev_rr_width :: !CUInt
- ev_rr_height :: !CUInt

RROutputChangeNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_subtype :: !CInt
- ev_output :: !RROutput
- ev_crtc :: !RRCrtc
- ev_rr_mode :: !RRMode
- ev_rotation :: !Rotation
- ev_connection :: !Connection
- ev_subpixel_order :: !SubpixelOrder

RROutputPropertyNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_subtype :: !CInt
- ev_output :: !RROutput
- ev_property :: !Atom
- ev_timestamp :: !Time
- ev_rr_state :: !CInt

ScreenSaverNotifyEvent |

Fields

- ev_event_type :: !EventType
- ev_serial :: !CULong
- ev_send_event :: !Bool
- ev_event_display :: Display
- ev_window :: !Window
- ev_root :: !Window
- ev_ss_state :: !XScreenSaverState
- ev_ss_kind :: !XScreenSaverKind
- ev_forced :: !Bool
- ev_time :: !Time

Instances

Show Event |
Instance details Defined in Graphics.X11.Xlib.Extras Methods showsPrec :: Int -> Event -> ShowS Source # show :: Event -> String Source # showList :: [Event] -> ShowS Source #
Message Event |
Instance details Defined in XMonad.Core

data WindowChanges Source #

Constructors

WindowChanges |

Fields

- wc_x :: CInt
- wc_y :: CInt
- wc_width :: CInt
- wc_height :: CInt
- wc_border_width :: CInt
- wc_sibling :: Window
- wc_stack_mode :: CInt

Instances

Storable WindowChanges |

Instance details

Defined in Graphics.X11.Xlib.Extras

Methods

sizeOf :: WindowChanges -> Int Source #

alignment :: WindowChanges -> Int Source #

peekElemOff :: Ptr WindowChanges -> Int -> IO WindowChanges Source #

pokeElemOff :: Ptr WindowChanges -> Int -> WindowChanges -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO WindowChanges Source #

pokeByteOff :: Ptr b -> Int -> WindowChanges -> IO () Source #

peek :: Ptr WindowChanges -> IO WindowChanges Source #

poke :: Ptr WindowChanges -> WindowChanges -> IO () Source #

data WindowAttributes Source #

Constructors

WindowAttributes |

Fields

- wa_x :: CInt
- wa_y :: CInt
- wa_width :: CInt
- wa_height :: CInt
- wa_border_width :: CInt
- wa_colormap :: Colormap
- wa_map_installed :: Bool
- wa_map_state :: CInt
- wa_override_redirect :: Bool

Instances

Storable WindowAttributes |

Instance details

Defined in Graphics.X11.Xlib.Extras

Methods

sizeOf :: WindowAttributes -> Int Source #

alignment :: WindowAttributes -> Int Source #

peekElemOff :: Ptr WindowAttributes -> Int -> IO WindowAttributes Source #

pokeElemOff :: Ptr WindowAttributes -> Int -> WindowAttributes -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO WindowAttributes Source #

pokeByteOff :: Ptr b -> Int -> WindowAttributes -> IO () Source #

peek :: Ptr WindowAttributes -> IO WindowAttributes Source #

poke :: Ptr WindowAttributes -> WindowAttributes -> IO () Source #

data TextProperty Source #

Constructors

TextProperty |

Fields

- tp_value :: CString
- tp_encoding :: Atom
- tp_format :: CInt
- tp_nitems :: Word64

Instances

Storable TextProperty |

Instance details

Defined in Graphics.X11.Xlib.Extras

Methods

sizeOf :: TextProperty -> Int Source #

alignment :: TextProperty -> Int Source #

peekElemOff :: Ptr TextProperty -> Int -> IO TextProperty Source #

pokeElemOff :: Ptr TextProperty -> Int -> TextProperty -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO TextProperty Source #

pokeByteOff :: Ptr b -> Int -> TextProperty -> IO () Source #

peek :: Ptr TextProperty -> IO TextProperty Source #

poke :: Ptr TextProperty -> TextProperty -> IO () Source #

newtype FontSet Source #

Constructors

FontSet (Ptr FontSet) |

Instances

Eq FontSet |
Instance details Defined in Graphics.X11.Xlib.Extras Methods (==) :: FontSet -> FontSet -> Bool Source # (/=) :: FontSet -> FontSet -> Bool Source #
Ord FontSet |
Instance details Defined in Graphics.X11.Xlib.Extras Methods compare :: FontSet -> FontSet -> Ordering Source # (<) :: FontSet -> FontSet -> Bool Source # (<=) :: FontSet -> FontSet -> Bool Source # (>) :: FontSet -> FontSet -> Bool Source # (>=) :: FontSet -> FontSet -> Bool Source # max :: FontSet -> FontSet -> FontSet Source # min :: FontSet -> FontSet -> FontSet Source #
Show FontSet |
Instance details Defined in Graphics.X11.Xlib.Extras Methods showsPrec :: Int -> FontSet -> ShowS Source # show :: FontSet -> String Source # showList :: [FontSet] -> ShowS Source #

data SizeHints Source #

Constructors

SizeHints |

Fields

- sh_min_size :: Maybe (Dimension, Dimension)
- sh_max_size :: Maybe (Dimension, Dimension)
- sh_resize_inc :: Maybe (Dimension, Dimension)
- sh_aspect :: Maybe ((Dimension, Dimension), (Dimension, Dimension))
- sh_base_size :: Maybe (Dimension, Dimension)
- sh_win_gravity :: Maybe BitGravity

Instances

Storable SizeHints |

Instance details

Defined in Graphics.X11.Xlib.Extras

Methods

sizeOf :: SizeHints -> Int Source #

alignment :: SizeHints -> Int Source #

peekElemOff :: Ptr SizeHints -> Int -> IO SizeHints Source #

pokeElemOff :: Ptr SizeHints -> Int -> SizeHints -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO SizeHints Source #

pokeByteOff :: Ptr b -> Int -> SizeHints -> IO () Source #

peek :: Ptr SizeHints -> IO SizeHints Source #

poke :: Ptr SizeHints -> SizeHints -> IO () Source #

data ClassHint Source #

Constructors

ClassHint |

Fields

- resName :: String
- resClass :: String

data WMHints Source #

Constructors

WMHints |

Fields

- wmh_flags :: CLong
- wmh_input :: Bool
- wmh_initial_state :: CInt
- wmh_icon_pixmap :: Pixmap
- wmh_icon_window :: Window
- wmh_icon_x :: CInt
- wmh_icon_y :: CInt
- wmh_icon_mask :: Pixmap
- wmh_window_group :: XID

Instances

Storable WMHints |

Instance details

Defined in Graphics.X11.Xlib.Extras

Methods

sizeOf :: WMHints -> Int Source #

alignment :: WMHints -> Int Source #

peekElemOff :: Ptr WMHints -> Int -> IO WMHints Source #

pokeElemOff :: Ptr WMHints -> Int -> WMHints -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO WMHints Source #

pokeByteOff :: Ptr b -> Int -> WMHints -> IO () Source #

peek :: Ptr WMHints -> IO WMHints Source #

poke :: Ptr WMHints -> WMHints -> IO () Source #

type XErrorEventPtr = Ptr () Source #

type CXErrorHandler = Display -> XErrorEventPtr -> IO CInt Source #

type XErrorHandler = Display -> XErrorEventPtr -> IO () Source #

data ErrorEvent Source #

Constructors

ErrorEvent |

Fields

- ev_type :: !CInt
- ev_display :: Display
- ev_serialnum :: !CULong
- ev_error_code :: !CUChar
- ev_request_code :: !CUChar
- ev_minor_code :: !CUChar
- ev_resourceid :: !XID

Instances

Show ErrorEvent Source # |
Instance details Defined in System.Taffybar.Information.SafeX11 Methods showsPrec :: Int -> ErrorEvent -> ShowS Source # show :: ErrorEvent -> String Source # showList :: [ErrorEvent] -> ShowS Source #

xFree :: Ptr a -> IO CInt Source #

data IORequest Source #

Constructors

IORequest |

Fields

- ioAction :: IO a
- ioResponse :: Chan (Either SafeX11Exception a)

data SafeX11Exception Source #

Constructors

SafeX11Exception |

Instances

Eq SafeX11Exception Source # |
Instance details Defined in System.Taffybar.Information.SafeX11 Methods (==) :: SafeX11Exception -> SafeX11Exception -> Bool Source # (/=) :: SafeX11Exception -> SafeX11Exception -> Bool Source #
Show SafeX11Exception Source # |
Instance details Defined in System.Taffybar.Information.SafeX11 Methods showsPrec :: Int -> SafeX11Exception -> ShowS Source # show :: SafeX11Exception -> String Source # showList :: [SafeX11Exception] -> ShowS Source #
Exception SafeX11Exception Source # |
Instance details Defined in System.Taffybar.Information.SafeX11 Methods toException :: SafeX11Exception -> SomeException Source # fromException :: SomeException -> Maybe SafeX11Exception Source # displayException :: SafeX11Exception -> String Source #

xGetGeometry :: Display -> Drawable -> Ptr Window -> Ptr Position -> Ptr Position -> Ptr Dimension -> Ptr Dimension -> Ptr Dimension -> Ptr CInt -> IO Status Source #

safeXGetWindowProperty :: Display -> Window -> Atom -> CLong -> CLong -> Bool -> Atom -> Ptr Atom -> Ptr CInt -> Ptr CULong -> Ptr CULong -> Ptr (Ptr CUChar) -> IO Status Source #

safeXGetWMHints :: Display -> Window -> IO (Ptr WMHints) Source #

rawGetWindowPropertyBytes :: Storable a => Int -> Display -> Atom -> Window -> IO (Maybe (ForeignPtr a, Int)) Source #

requestQueue :: Chan IORequest Source #

x11Thread :: ThreadId Source #

withErrorHandler :: XErrorHandler -> IO a -> IO a Source #

startHandlingX11Requests :: IO () Source #

handleX11Requests :: IO () Source #

postX11RequestSync :: IO a -> IO (Either SafeX11Exception a) Source #

postX11RequestSyncDef :: a -> IO a -> IO a Source #

rawGetWindowProperty :: Storable a => Int -> Display -> Atom -> Window -> IO (Maybe [a]) Source #

getWindowProperty8 :: Display -> Atom -> Window -> IO (Maybe [CChar]) Source #

getWindowProperty16 :: Display -> Atom -> Window -> IO (Maybe [CShort]) Source #

getWindowProperty32 :: Display -> Atom -> Window -> IO (Maybe [CLong]) Source #

getWMHints :: Display -> Window -> IO WMHints Source #

safeGetGeometry :: Display -> Drawable -> IO (Window, Position, Position, Dimension, Dimension, Dimension, CInt) Source #

outParameters7 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f, Storable g) => (IO r -> IO ()) -> (Ptr a -> Ptr b -> Ptr c -> Ptr d -> Ptr e -> Ptr f -> Ptr g -> IO r) -> IO (a, b, c, d, e, f, g) Source #

# Orphan instances

Show ErrorEvent Source # |
Instance details Methods showsPrec :: Int -> ErrorEvent -> ShowS Source # show :: ErrorEvent -> String Source # showList :: [ErrorEvent] -> ShowS Source #